// AcTree.h: interface for the AcTree class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ACTREE_H__DFB17C13_2216_4076_BC79_1AD91B8704B1__INCLUDED_)
#define AFX_ACTREE_H__DFB17C13_2216_4076_BC79_1AD91B8704B1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CompoundComponent;

class AcTreeNode;
class AcTree  
{
public:
	enum {
		maxAcTreeDepth = 10
	};

	long getNumNodes();
	void finish();
	bool checkComponent(CompoundComponent * com);
	void addComponent(CompoundComponent * com);
	AcTree(long numComponents);
	virtual ~AcTree();
	inline AcTreeNode * getRoot() { return m_root; };
	inline long getNumSequences() { return m_numSequences; };

private:
	long m_numSequences;
	long m_numComponents;
	long m_numNodes;

	AcTreeNode * m_root;
	AcTreeNode * m_level[maxAcTreeDepth];
};

#endif // !defined(AFX_ACTREE_H__DFB17C13_2216_4076_BC79_1AD91B8704B1__INCLUDED_)
