// omponent.cpp: implementation of the Component class.
//
//////////////////////////////////////////////////////////////////////

#include "Component.h"
#include "Writer.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// contains resulting direction if 'first' component is followed by 'second'
// indexing: first * 8 + second
Direction Component::s_combine[64] = 
{
	TF, TFX, TL, TLX, TB, TBX, TR, TRX,
	TFX, TF, TRX, TR, TBX, TB, TLX, TL,
	TL, TLX, TB, TBX, TR, TRX, TF, TFX, 
	TLX, TL, TFX, TF, TRX, TR, TBX, TB,
	TB, TBX, TR, TRX, TF, TFX, TL, TLX,
	TBX, TB, TLX, TL, TFX, TF, TRX, TR,
	TR, TRX, TF, TFX, TL, TLX, TB, TBX,
	TRX, TR, TBX, TB, TLX, TL, TFX, TF
};

// contains direction of second component if 'first' component combined with it results in 'result' direction
// indexing: first * 8 + result
Direction Component::s_decombine[64] = 
{
	TF, TFX, TL, TLX, TB, TBX, TR, TRX,
	TFX, TF, TRX, TR, TBX, TB, TLX, TL,
	TR, TRX, TF, TFX, TL, TLX, TB, TBX,
	TLX, TL, TFX, TF, TRX, TR, TBX, TB,
	TB, TBX, TR, TRX, TF, TFX, TL, TLX,
	TBX, TB, TLX, TL, TFX, TF, TRX, TR,
	TL, TLX, TB, TBX, TR, TRX, TF, TFX,
	TRX, TR, TBX, TB, TLX, TL, TFX, TF
};

// contains direction of first component if it followed by 'second' results in 'result'
// indexing: result * 8 + second
//   F,  FX,  L,  LX,  B,  BX,  R,  RX
Direction Component::s_subtract[64] = 
{
	TF, TFX, TR, TLX, TB, TBX, TL, TRX,
	TFX, TF, TLX, TR, TBX, TB, TRX, TL,
	TL, TLX, TF, TBX, TR, TRX, TB, TFX,
	TLX, TL, TBX, TF, TRX, TR, TFX, TB,
	TB, TBX, TL, TRX, TF, TFX, TR, TLX,
	TBX, TB, TRX, TL, TFX, TF, TLX, TR,
	TR, TRX, TB, TFX, TL, TLX, TF, TBX,
	TRX, TR, TFX, TB, TLX, TL, TBX, TF
};

